import os
import json

SUCCESS_EXITCODE = 0
ERROR_EXITCODE = 1

ROOT_DIRECTORY = os.path.join(os.path.expanduser('~'), '.abeja')
CONFIG_FILE_PATH = os.path.join(ROOT_DIRECTORY, 'config')
LOG_DIRECTORY = os.path.join(os.path.expanduser('~'), '.abeja', 'log')
LOG_FILE_PATH = os.path.join(LOG_DIRECTORY, 'abejacli.log')

ABEJA_API_URL = os.environ.get('ABEJA_API_URL', 'https://api.abeja.io')
CONFIG = None
ABEJA_PLATFORM_USER_ID = None
ABEJA_PLATFORM_TOKEN = None
ORGANIZATION_NAME = None
ORGANIZATION_ENDPOINT = None
SAMPLE_MODEL_PATH = os.environ.get(
    'SAMPLE_MODEL_PATH',
    'https://s3-ap-northeast-1.amazonaws.com/abeja-platform-config-prod'
)
STDERROR_LOG_LEVEL = os.environ.get('LOG_LEVEL', 'ERROR')
DATALAKE_ITEMS_PER_PAGE = int(os.environ.get('DATALAKE_ITEMS_PER_PAGE', 100))
HTTP_READ_CHUNK_SIZE = int(os.environ.get('HTTP_READ_CHUNK_SIZE', 1024))
FILE_READ_CHUNK_SIZE = int(os.environ.get('FILE_READ_CHUNK_SIZE', 8192))
JOB_WORKER_THREAD_NUM = int(os.environ.get('JOB_WORKER_THREAD_NUM', 10))
PLATFORM_REQUEST_TIMEOUT_SECONDS = int(os.environ.get('PLATFORM_REQUEST_TIMEOUT_SECONDS', 300))

SERVICE_API_TIMEOUT = 90

DATASET_CHUNK_SIZE = 500


if os.path.exists(CONFIG_FILE_PATH):
    with open(CONFIG_FILE_PATH, 'r') as f:
        CONFIG = json.load(f)
    ABEJA_PLATFORM_USER_ID = os.environ.get('ABEJA_PLATFORM_USER', CONFIG['abeja-platform-user'])
    ABEJA_PLATFORM_TOKEN = os.environ.get('PERSONAL_ACCESS_TOKEN', CONFIG['personal-access-token'])
    ORGANIZATION_NAME = os.environ.get('ORGANIZATION_NAME', CONFIG['organization-name'])

ORGANIZATION_ENDPOINT = "{}/organizations/{}".format(ABEJA_API_URL, ORGANIZATION_NAME)
protocol, fqdn = ABEJA_API_URL.split('://')
WEB_API_ENDPOINT = '{}://{}.{}'.format(protocol, ORGANIZATION_NAME, fqdn)

ENV_VAR_KEY_FORMAT = r'^[a-zA-Z_][a-zA-Z0-9_]*$'

TRIGGER_DEFAULT_RETRY_COUNT = 5
RUN_DEFAULT_RETRY_COUNT = 5
